# -*- coding: utf-8 -*-
from setuphelpers import *
import tempfile

target_dir= makepath(programfiles32,"Spotify")
target_bin = makepath(target_dir,'Spotify.exe')

def install():
    # Installing the software
    
    if force or (not isfile(target_bin)) or Version(get_version_from_binary(target_bin,property_name="FileVersion")) < Version(control.get_software_version()):
        killalltasks('Spotify')
        if isdir(target_dir):
            remove_tree(target_dir)
        print('Run : SpotifyFullSetup.exe /extract "%s"' % target_dir)
        run('SpotifyFullSetup.exe /extract "%s"' % target_dir)

        if not isfile(target_bin):
            error('%s not found' % target_bin)

        if Version(get_version_from_binary(target_bin,property_name="FileVersion")) < Version(control.get_software_version()) :
            error("Spotify installation did not work well")
    else:
        print('Skip Spotify already install')

    create_programs_menu_shortcut('Spotify',target_bin)

def uninstall():
    killalltasks('Spotify')
    remove_tree(target_dir)
    remove_programs_menu_shortcut('Spotify')

def audit():
    if not isfile(target_bin):
        print('%s not found' % target_bin)    
        return "ERROR"
    spotversion = get_version_from_binary(target_bin,property_name="FileVersion")
    if (not isfile(target_bin)) or Version(spotversion) < Version(control.get_software_version()):
        print('Spotify is not in the correct version (%s , %s)' % (spotversion,control.get_software_version()))
        return "ERROR"
    else:
        return "OK"

def session_setup():

    spotify_uappdata = makepath(user_appdata(),'Spotify')
    
    if reg_key_exists(HKEY_CURRENT_USER, r"SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\Spotify"):
        killalltasks('Spotify')
        tmpspotify = makepath(tempfile.gettempdir(),'spotify-mig')
        mkdirs(tmpspotify)

        if isdir(makepath(spotify_uappdata,"Users")) :
            copytree2(makepath(spotify_uappdata,"Users"),makepath(tmpspotify,"Users"))

        if isfile(makepath(spotify_uappdata,'prefs')):
            filecopyto(makepath(spotify_uappdata,'prefs'),makepath(tmpspotify,'prefs'))

        if isdir(spotify_uappdata) :
            remove_tree(spotify_uappdata)
            copytree2(tmpspotify,spotify_uappdata)
            
        remove_tree(tmpspotify)

        if isfile(os.path.join(desktop(0), 'Spotify.lnk')):
            
            remove_user_desktop_shortcut('Spotify')
            create_user_desktop_shortcut('Spotify',target_bin)

        registry_deletekey(HKEY_CURRENT_USER, r"SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall","Spotify")
        remove_user_programs_menu_shortcut('Spotify')
    

